using System;

interface IStorable
{
	void Read();
	void Write();
}

// IStorable ϵ Document ϰ ߴ.
public class Document : IStorable
{
	// Document 
	public Document(string s) 
	{
		Console.WriteLine(
			"Creating document with: {0}", s);
        
	}
    
	// Read  . 
	public virtual void Read()
	{
		Console.WriteLine(
			"Document Read Method for IStorable");        
	}

	// NB:  ƴϴ(Not Virtual!).
	public void Write()
	{
		Console.WriteLine(
			"Document Write Method for IStorable");  
	}

}

// Document ĻǾ.
public class Note : Document
{
	public Note(string s):
		base(s)
	{
		Console.WriteLine(
			"Creating note with: {0}", s);
	}

	// Read ޼ҵ带 ̵Ѵ.
	public override void Read()
	{
		Console.WriteLine(
			"Overriding the Read method for Note!");
	}

	// Write ޼ҵ 
	public void Write()
	{
		Console.WriteLine(
			"Implementing the Write method for Note!");        
	}
} 
public class Tester
{

	static void Main()
	{
		// Document ü Ѵ.
		Document theNote = new Note("Test Note");
		IStorable isNote = theNote as IStorable;
		if (isNote != null)
		{
			isNote.Read();
			isNote.Write();
		}

		Console.WriteLine("\n");

		// ޼ҵ带  ȣѴ.
		theNote.Read();
		theNote.Write();

		Console.WriteLine("\n");

		// Note ü Ѵ. 
		Note note2 = new Note("Second Test");
		IStorable isNote2 = note2 as IStorable;
		if (isNote != null)
		{
			isNote2.Read();
			isNote2.Write();
		}

		Console.WriteLine("\n");

		// ޼ҵ带  ȣѴ. 
		note2.Read();
		note2.Write();
	}
}

