using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Http;

namespace Programming_CSharp
{
	//  Ŭ Ѵ. 
	public class Calculator : MarshalByRefObject, ICalc
	{
		public Calculator()
		{
			Console.WriteLine("Calculator constructor");
		}

		//   Լ Ѵ.
		public double Add(double x, double y)
		{
			Console.WriteLine("Add {0} + {1}", x, y);
			return x+y;
		}
		public double Sub(double x, double y)
		{
			Console.WriteLine("Sub {0} - {1}", x, y);
			return x-y;
		}
		public double Mult(double x, double y)
		{
			Console.WriteLine("Mult {0} * {1}", x, y);
			return x*y;
		}
		public double Div(double x, double y)
		{
			Console.WriteLine("Div {0} / {1}", x, y);
			return x/y;
		}
	}

	public class ServerTest
	{
		public static void Main()
		{
			// ä Ͽ Ѵ. 
			HttpChannel chan = new HttpChannel(65100);
			ChannelServices.RegisterChannel(chan);

			Type calcType = 
				Type.GetType("Programming_CSharp.Calculator");

			// Ϲ Ÿ ϰ,   
			//  Ÿ  "theEndPoint" Ѵ.
			RemotingConfiguration.RegisterWellKnownServiceType
				( calcType,               
					"theEndPoint",
					WellKnownObjectMode.Singleton );

			//   Է ٸ.
			Console.WriteLine("Press [enter] to exit...");
			Console.ReadLine();
		}
	}
}

